package net.sf.sql2java.common.beans;

import java.util.Iterator;
import java.util.Stack;

public class BreadCrumbs extends Stack<BreadCrumbs.BreadCrumb> {
	private static final long serialVersionUID = -98519772747338852L;

// -- String Conversion -------------------------------------------------------
	
	@Override
	public String toString() {
		// -- create the result
		StringBuilder result = new StringBuilder();
		
		Iterator<BreadCrumb> iter = iterator();
		int i = 0;
		while (iter.hasNext()) {
			BreadCrumb crumb = iter.next();
			
			if (i++ != 0) result.append(".");
			
			result.append(crumb.getSection()).append("(");
			result.append(crumb.getChild()).append(")");
		}
		
		// -- return the result
		return result.toString();
	}
	
// -- BreadCrumb Management ---------------------------------------------------
	
	public void register(String section, String childKey) {
		add(new BreadCrumb(section, childKey));
	}
	
// -- internal BreadCrumb Class -----------------------------------------------
	
	protected static class BreadCrumb {
		private String section;
		private String child;
		
		public BreadCrumb(String section, String child) {
			this.section = section;
			this.child = child;
		}
		
		public String getChild() {
			return child;
		}
		
		public String getSection() {
			return section;
		}
	}
}
