package net.sf.sql2java.data;

public class Pointer {
	protected String name;
	
// -- Constructors ------------------------------------------------------------
	
	public Pointer(String name) {
		this.name = name;
	}
	
// -- Convertors --------------------------------------------------------------
	
	public String toString() {
		return name;
	}

// -- Creation ----------------------------------------------------------------
	
	public static Pointer parse(String element) {
		// -- create the result
		Pointer result = null;
		
		if (element.indexOf(MapPointer.START_SEPARATOR) != -1) {
			if (element.indexOf(MapPointer.STOP_SEPARATOR) == -1)
				throw new RuntimeException(
						String.format("No stop separator found in path %s", element));
			
			result = MapPointer.createPointer(element);
		} else {
			result = new Pointer(element);
		}
		
		// -- return the result
		return result;
	}
	
// -- Comparison --------------------------------------------------------------
	
	@Override
	public int hashCode() {
		int result = 19;
		int c = 0;
		
		c += name.hashCode();
			
		result = (37 * result) + c;
		
		return result;
	}
	
	public boolean equals(Object obj) {
		if (obj == null) return false;
		
		if (obj instanceof String) {
			return toString().equals((String) obj);
		} else if (obj instanceof Pointer) {
			Pointer p = (Pointer) obj;
			
			return p.getName().equals(name);
		} else
			return false;
	}
	
// -- Getters -----------------------------------------------------------------
	
	public String getName() {
		return name;
	}
}
